=== Packaging/debian/changelog ===
devilutionx (1.0.1) UNRELEASED; urgency=medium

  * New release

  * Features:
  * Toggle fullscreen at any point by hitting alt+enter (mouse grab can be disabled in diablo.ini)
  * Controller: B button closes the currently active panel.
  * Added a navigation menu for controllers
  * Focus on the exit item before quitting.
  * Minor performance improvements (save/load time and main menu).
  * Add a list of known mods


  * Platforms:
  * Added support for ppc64le
  * Added support for Amiga
  * Added support Clockwork PI GameShell
  * Added support for GKD350h
  * Switch to OPK for RetroFW (requires 2.0)
  * Update OpendDingus/RetroFW build root


  * Bugfixes:
  * Game crashing on systems that do not report monitor refresh rate.
  * Fixed belt not working correctly when holding shift on us keyboard layouts
  * Always keep track of the latest hero level when selecting difficulty.
  * Correct screenshot path
  * Turn the screen red for 200ms when taking screenshots.
  * Fix town load screen missing on the first load for 32bit systems.
  * Fix minor HOM issue at some houses in town.
  * Allow for space as text input
  * Fixed a couple of typos in error messages

  * Original Diablo bugs:
  * Fix belt not working correctly when holding shift on *non-*us keyboard layouts
  * Fix one more rare crash.

 -- Goran Vidovic (gogo) <trebelnik2@gmail.com>  Sat, 14 Mar 2020 16:10:11 +0200

devilutionx (1.0.0) UNRELEASED; urgency=medium

  * New release

  * Features:
  * FPS no longer capped at 20hz; smoother mouse and transitions
  * Full-featured gamepad support
  * All movies can now be skipped via ESC
  * Implement --help, --version and --data-dir
  * Implement FPS counter (-f)
  * Force windowed mode with -x
  * Skip startup movies with -n
  * Implement scroll wheel navigation
  * Implement touch support
  * Load assets from the same folder as the mpq
  * Faster loading

  * Platforms:
  * Added Nintendo Switch support
  * Added Retro Gamer Handheld (OpenDingux/Retrofw) support
  * Added OpenBSD support
  * Windows version is now build as GUI an app and has an icon

  * Bugfixes:
  * Fixed random missing sounds
  * Fixed NPCs not talking about the right quest
  * Error messages implemented in GUI
  * Fixed having to restart the game between network sessions
  * Fixed game not working on some Radeon GPUs
  * Fixed panel missing after minimizing game if upscaling is disabled
  * Fixed clicks in the left letterbox being incorrectly handled
  * Fixed end movie not looping

  * Original Diablo bugs:
  * Fixed a large number of rare stability issues from the original game
  * Correctly take open panels into account when casting spells
  * Fix sound some times being muted after Diablo dies

 -- Goran Vidovic (gogo) <trebelnik2@gmail.com>  Thu, 02 Jan 2019 21:35:11 +0200

devilutionx (0.5.0.3) UNRELEASED; urgency=medium

  * Hardcoded font path fix

 -- Vítězslav Dvořák <info@vitexsoftware.cz>  Mon, 07 Oct 2019 23:35:11 +0200

devilutionx (0.5.0.2) UNRELEASED; urgency=medium

  [ Vítězslav Dvořák ]
    Missing font hotfix
  * 
