=== Packaging/debian/control ===
Source: devilutionx
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends:
	debhelper (>= 9),
	cmake,
	git,
	g++,
	gettext,
	libsdl2-mixer-dev,
	libsdl2-ttf-dev,
	libsodium-dev
Standards-Version: 4.3.0
Homepage: https://github.com/diasurgical/devilutionX
Vcs-Git: git://git@github.com:diasurgical/devilutionX.git
Vcs-Browser: https://github.com/diasurgical/devilutionX.git

Package: devilutionx
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 devilutionx-data | diablo-data | game-data-packager (>= 40),
Description: Diablo build for modern operating systems
 Diablo by Blizzard Entertainment is undoubtedly one of 
 the best games of the 1990s 

Package: diablo-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 devilutionx | diablo,
Description: Diablo game data
 Copy diabdat.mpq from your CD, or GoG install folder
